#include "constants.h"

#pragma OPENCL EXTENSION cl_khr_fp64: enable           //FIXED
__kernel void ComputeResidual(__global const REAL* restrict x, 
                              __global const REAL* restrict dx_dt,
                              __global REAL* restrict F)
{

    int i = get_global_id(0);
    int j = get_global_id(1);

    for (int var=0; var<DOF; var++) {
        if (i<N1-1 && j<N2-1) {
            F[INDEX_GLOBAL(i,j,var)] = dx_dt[INDEX_GLOBAL(i,j,var)] -
                                   (x[INDEX_GLOBAL(i+1,j,var)] - 
                                    x[INDEX_GLOBAL(i,j,var)])/DX1 -
                                   (x[INDEX_GLOBAL(i,j+1,var)] - 
                                    x[INDEX_GLOBAL(i,j,var)])/DX2;
        }
    }
}

